<?php

/**
 * NOTE: This file is auto generated by OpenAPI Generator.
 * Do NOT edit it manually. Run `php artisan openapi:generate-server`.
 */

use App\Http\ApiV1\Modules\Auth\Controllers\AuthController;
use App\Http\ApiV1\Modules\Auth\Controllers\ConfirmationCodesController;
use App\Http\ApiV1\Modules\Baskets\Controllers\BasketCalculatorsController;
use App\Http\ApiV1\Modules\Baskets\Controllers\BasketsController;
use App\Http\ApiV1\Modules\Catalog\Controllers\BrandsController;
use App\Http\ApiV1\Modules\Catalog\Controllers\CategoriesController;
use App\Http\ApiV1\Modules\Catalog\Controllers\OffersController;
use App\Http\ApiV1\Modules\Catalog\Controllers\ReviewsController;
use App\Http\ApiV1\Modules\Cms\Controllers\Banners\BannersController;
use App\Http\ApiV1\Modules\Cms\Controllers\PagesController;
use App\Http\ApiV1\Modules\Cms\Controllers\SeoSectionsController;
use App\Http\ApiV1\Modules\Common\Controllers\FilesController;
use App\Http\ApiV1\Modules\Communication\Controllers\NotificationsController;
use App\Http\ApiV1\Modules\Crm\Controllers\FavoritesController;
use App\Http\ApiV1\Modules\Orders\Controllers\OrdersController;
use App\Http\ApiV1\Modules\Units\Controllers\SellersController;
use Illuminate\Support\Facades\Route;

Route::post('common/files/download-protected', [FilesController::class, 'downloadProtected'])->middleware(['auth']);
Route::post('auth/user', [AuthController::class, 'register']);
Route::post('auth/login', [AuthController::class, 'login']);
Route::post('auth/login-by-code', [AuthController::class, 'loginByCode']);
Route::get('auth/logout', [AuthController::class, 'logout'])->middleware(['auth']);
Route::post('auth/refresh', [AuthController::class, 'refresh']);
Route::post('auth/confirmation-code', [ConfirmationCodesController::class, 'create']);
Route::post('lk/orders:search', [OrdersController::class, 'customerOrdersList'])->middleware(['auth']);
Route::get('lk/orders/{id}', [OrdersController::class, 'customerOrdersGet'])->middleware(['auth']);
Route::post('customers/notifications:search', [NotificationsController::class, 'search'])->middleware(['auth']);
Route::post('customers/notifications:viewed', [NotificationsController::class, 'massSetViewed'])->middleware(['auth']);
Route::post('baskets:set-item', [BasketsController::class, 'setItems'])->middleware(['auth']);
Route::post('baskets:set-promo', [BasketCalculatorsController::class, 'promoCode'])->middleware(['auth']);
Route::post('baskets:current', [BasketCalculatorsController::class, 'current'])->middleware(['auth']);
Route::delete('baskets', [BasketsController::class, 'delete'])->middleware(['auth']);
Route::post('orders/{id}/get-qr-image', [OrdersController::class, 'getQrImage'])->middleware(['auth']);
Route::post('checkout/order', [OrdersController::class, 'commit'])->middleware(['auth']);
Route::post('checkout/data', [OrdersController::class, 'getCheckoutData'])->middleware(['auth']);
Route::get('checkout/typ/{id}', [OrdersController::class, 'get'])->middleware(['auth']);
Route::post('catalog/offers:search', [OffersController::class, 'search']);
Route::get('catalog/offers/{id}', [OffersController::class, 'get']);
Route::get('catalog/categories', [CategoriesController::class, 'tree']);
Route::get('catalog/brands/{id}', [BrandsController::class, 'get']);
Route::post('catalog/brands:search', [BrandsController::class, 'search']);
Route::post('catalog/reviews-create', [ReviewsController::class, 'create'])->middleware(['auth']);
Route::delete('catalog/reviews/{id}', [ReviewsController::class, 'delete'])->middleware(['auth']);
Route::post('catalog/reviews:search', [ReviewsController::class, 'search']);
Route::post('catalog/favorite-products:add', [FavoritesController::class, 'massAdd'])->middleware(['auth']);
Route::delete('catalog/favorite-products', [FavoritesController::class, 'massDelete'])->middleware(['auth']);
Route::post('catalog/favorite-products:search', [FavoritesController::class, 'search'])->middleware(['auth']);
Route::get('sections/products/{id}', [SeoSectionsController::class, 'getProductSection']);
Route::post('pages:search', [PagesController::class, 'search']);
Route::post('banners:search', [BannersController::class, 'search']);
Route::post('sellers', [SellersController::class, 'create']);
